<template>
  <box>
    <template v-slot:title>
      {{ capitalizeFirstLetter(action) }} Redirect Url
    </template>

    <div class="px-3 w-full h-24 flex flex-row">
      <lull-input
        class="w-2/4 pr-5 flex-grow"
        label="Url:"
        :class="[hasError('url') && 'shake']"
        :message="getValidationMessage('url')"
        :status="getValidationStatus('url')"
        v-model="redirectUrls.url"
      />

      <lull-select
        class="w-1/4 pr-5 flex-grow"
        label="Type:"
        :class="[hasError('urlType') && 'shake']"
        :message="getValidationMessage('urlType')"
        :status="getValidationStatus('urlType')"
        :options="options"
        v-model="redirectUrls.urlType"
      />

      <div class="flex flex-col flex-grow-0 text-right">
        <label>Primary:</label>
        <lull-switch
          name="primary"
          label="primary"
          v-model="redirectUrls.isPrimary"
        />
      </div>
    </div>

    <div class="flex flex-row w-full justify-end pt-5">
      <lull-button type="danger" @click="cancel()">Cancel</lull-button>
      <lull-button class="ml-3" type="info" @click="save()">Save</lull-button>
    </div>
  </box>
</template>

<script lang="ts">
import { defineComponent, onMounted, onUpdated, reactive } from 'vue';
import { SelectOption } from '@/core/types/SelectOption';
import { ClientRedirectUrl } from '@/core/models/client/ClientRedirectUrl';
import { UrlType } from '@/core/types/UrlType';
import {
  enumToSelectOptions,
  capitalizeFirstLetter,
} from '@/core/helpers/util';
import { ManageAction } from '@/core/types/ManageAction';
import { useStore } from '@/store';
import { ClientAction } from '@/store/Clients/ClientModule';
import useValidation from '@/core/composables/useValidations';
import { required, url } from '@vuelidate/validators';

export default defineComponent({
  name: 'redirect-url',
  emit: ['close', 'refresh'],
  props: {
    action: { type: String, required: false, default: ManageAction.Create },
    clientId: { type: String, required: true },
    redirectUrl: { type: Object, required: false, default: () => ({}) },
  },
  setup(props, { emit }) {
    const store = useStore();
    const redirectUrls: Partial<ClientRedirectUrl> = reactive({});
    const urlTypeEnum = enumToSelectOptions(UrlType);
    const options = urlTypeEnum.map((x: SelectOption) => x.label);

    const rules = {
      urlType: { required },
      url: { required, url },
    };

    const {
      validation,
      getValidationMessage,
      getValidationStatus,
      hasError,
    } = useValidation(rules, redirectUrls, { $stopPropagation: true });

    function cancel(): void {
      validation.value.$reset();
      emit('close');
    }

    async function save(): Promise<void> {
      validation.value.$touch();
      if (validation.value.$invalid) {
        return;
      }

      const action =
        props.action === ManageAction.Create
          ? `client/${ClientAction.AddRedirectUrl}`
          : `client/${ClientAction.UpdateRedirectUrl}`;

      const results = await store.dispatch(action, {
        clientId: props.clientId,
        redirectUrl: redirectUrls,
      });

      if (results) {
        validation.value.$reset();
        emit('refresh');
      }
    }

    onMounted(() => {
      if (props.redirectUrl) {
        Object.assign(redirectUrls, props.redirectUrl);
      }
    });

    onUpdated(() => {
      if (props.redirectUrl) {
        Object.assign(redirectUrls, props.redirectUrl);
      }
    });

    return {
      redirectUrls,
      options,
      cancel,
      save,
      capitalizeFirstLetter,
      validation,
      getValidationMessage,
      getValidationStatus,
      hasError,
    };
  },
});
</script>